'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _Accounts = require('../modules/common/Accounts');

var _Accounts2 = _interopRequireDefault(_Accounts);

var _BaseClient2 = require('./BaseClient');

var _BaseClient3 = _interopRequireDefault(_BaseClient2);

var _Encyclopedia = require('../modules/WorldOfWarships/Encyclopedia');

var _Encyclopedia2 = _interopRequireDefault(_Encyclopedia);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @classdesc The World of Warships API client.
 * @extends BaseClient
 */
var WorldOfWarships = function (_BaseClient) {
  _inherits(WorldOfWarships, _BaseClient);

  /**
   * Constructor.
   * @param {ClientOptions} options - The client options.
   */
  function WorldOfWarships(options) {
    _classCallCheck(this, WorldOfWarships);

    /**
     * The client's Accounts module.
     * @type {Accounts}
     */
    var _this = _possibleConstructorReturn(this, (WorldOfWarships.__proto__ || Object.getPrototypeOf(WorldOfWarships)).call(this, _extends({}, options, { type: 'wows' })));

    _this.accounts = new _Accounts2.default(_this);

    /**
     * The client's Encyclopedia module.
     * @type {Encyclopedia}
     */
    _this.encyclopedia = new _Encyclopedia2.default(_this);
    return _this;
  }

  return WorldOfWarships;
}(_BaseClient3.default);

exports.default = WorldOfWarships;