"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * @classdesc A module within an API client.
 */
var ClientModule =
/**
 * Constructor.
 * @param {BaseClient} client - The API client this module belongs to.
 * @param {string} name - The name of the module.
 */
function ClientModule(client, name) {
  _classCallCheck(this, ClientModule);

  /**
   * The API client this module belongs to.
   * @type {BaseClient}
   */
  this.client = client;

  /**
   * The name of the module.
   * @type {string}
   */
  this.name = name;
};

exports.default = ClientModule;