"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = hashCode;
/**
 * JavaScript version of Java's String.hashCode() method.
 * @param {string} string - The string to hash.
 * @return {string} The hashed string.
 * @private
 */
function hashCode(string) {
  var hash = 0;

  if (!string.length) {
    return hash.toString();
  }

  for (var i = 0; i < string.length; ++i) {
    var char = string.charCodeAt(i);

    hash = (hash << 5) - hash + char;
    hash &= hash;
  }

  return hash.toString();
}